<?php
namespace Claromentis\Console\Util;

$GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"] = (@$GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"] ?: array()) + array("_3e09962b663b985b" . "f8c260ac2e95edc0" => base64_decode("Y29" . "yZQ" . "=="), "_4c93d4c40f7ab1a488c38" . "7f7f91a6496" => base64_decode("Q2hlY2tpbmcgaW5zdGF" . "sbGF0aW9uLi4u"), "_7b2ca9a105acfcc088d2c15bfe645" . "8b6" => base64_decode("Q29yZSBpc" . "yBub3QgaW" . "5zdGFsbGV" . "k"), "_77713ce23683636d0573408" . "c9a0d0ddb" => base64_decode("RGF0YWJhc2UgcGVyb" . "Wlzc2lvbnMgYXJlIG" . "FkZXF1YXRl"), "_9636e445fb" . "eaa4bbfe569" . "4ed532de0b1" => base64_decode("RGF0YWJhc2UgcGVybWlzc2lvbnMg" . "aW5zdWZmaWNpZW50"), "_9810a28102741282" . "00cb24f15909a3f2" => base64_decode("Q2hlY2tpbmcgZGF0YWJhc2UgcGVybWlzc2l" . "vbnMuLi4="), "_5bcefc1eff68a" . "2aa6ab8f35699a" . "56d08" => base64_decode("RGF0YWJhc2UgaXMgbm9" . "0IGF2YWlsYWJsZTog"), "_1094b976516d8df" . "54067d448e66e029" . "7" => base64_decode("RGF0YWJhc2UgaXMgYXZhaWxh" . "Ymxl"), "_a70083b91f8d" . "3b0237061e068" . "26958e8" => base64_decode("Q2hlY2tpbmcgZGF0YWJhc2" . "UgYXZhaWxhYmlsaXR5Li4u"));
use Claromentis\Core\Config\Config;
use Claromentis\Core\DAL\DbFactory;
use Claromentis\Core\Module;
use Claromentis\Setup\Exception\NotInstalledException;
use Claromentis\Setup\Task\DatabaseCheck;
use Psr\Log\LoggerAwareInterface;
use Psr\Log\LoggerAwareTrait;
use Psr\Log\NullLogger;
use RuntimeException;




class InstallationChecker implements LoggerAwareInterface
{
    use LoggerAwareTrait;
    protected Config $config;
    protected DbFactory $factory;
    protected Locator $locator;
    protected Module\Api $modules;
    
    
    
    
    
    
    
    
    
    public function __construct(Config $_fd33b1a14db9a1eccfaaa3cb67b5336e, DbFactory $_c8ef295ed962a46e6246480731bf7b99, Locator $_958a49c0e9814c5c29eb8698e3fb6de2, Module\Api $_59eea0afb98cc6c83c49d730362a45fd)
    {
        $this->config = $_fd33b1a14db9a1eccfaaa3cb67b5336e;
        $this->factory = $_c8ef295ed962a46e6246480731bf7b99;
        $this->locator = $_958a49c0e9814c5c29eb8698e3fb6de2;
        $this->modules = $_59eea0afb98cc6c83c49d730362a45fd;
        $this->setLogger(new NullLogger());
    }
    
    
    
    
    
    
    public function isInstalled()
    {
        try {
            $this->logger->info($GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_4c93d4c40f7ab1a488c387" . "f7f91a6496"]);
            $this->verifyInstalled();
        } catch (\Exception $_c35473364fa7a050299058f332ec29c1) {
            return false;
        }
        return true;
    }
    
    
    
    
    
    
    public function checkDatabaseConnection()
    {
        try {
            $this->logger->info($GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_a70083b91f8d3b0237061e0682" . "6958e8"]);
            $this->verifyDatabaseConnection();
            $this->logger->debug($GLOBALS["__65da1b1ec2d6653e8a0" . "ab7848e536215"]["_1094b976516d8df54067" . "d448e66e0297"]);
        } catch (\Exception $_c35473364fa7a050299058f332ec29c1) {
            
            
            
            $this->logger->info($GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_5bcefc1eff68a2" . "aa6ab8f35699a56" . "d08"] . $_c35473364fa7a050299058f332ec29c1->getMessage());
            return false;
        }
        return true;
    }
    
    
    
    
    
    
    public function checkDatabasePermissions()
    {
        try {
            $this->logger->info($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_9810a2810274128200cb2" . "4f15909a3f2"]);
            $this->verifyDatabasePermissions();
            $this->logger->debug($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_77713ce23683636d0573408c9a0d0dd" . "b"]);
        } catch (\Exception $_c35473364fa7a050299058f332ec29c1) {
            
            
            return false;
        }
        return true;
    }
    
    
    
    
    
    
    
    public function verifyInstalled()
    {
        $this->verifyDatabaseConnection();
        $this->verifyDatabasePermissions();
        if (!$this->modules->isInstalled($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_3e09962b663b985bf8c260ac2e95e" . "dc0"])) {
            throw new NotInstalledException($GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_7b2ca9a105acfcc088d2c15bf" . "e6458b6"]);
        }
    }
    
    
    
    
    
    
    
    public function verifyDatabaseConnection()
    {
        
        
        $_4504853ce5094b088c8bdc3d570a0a5d = $this->getDatabase();
        
        
        $this->modules->setDatabase($_4504853ce5094b088c8bdc3d570a0a5d);
    }
    
    
    
    
    
    
    
    public function verifyDatabasePermissions()
    {
        $_4504853ce5094b088c8bdc3d570a0a5d = $this->getDatabase();
        $_58bc0ced402c33be307fe4d3d5433ed1 = new DatabaseCheck($this->config, $_4504853ce5094b088c8bdc3d570a0a5d);
        $_58bc0ced402c33be307fe4d3d5433ed1->setLogger($this->logger);
        if (!$_58bc0ced402c33be307fe4d3d5433ed1->Check()) {
            foreach ($_58bc0ced402c33be307fe4d3d5433ed1->GetErrors() as $_ba3845cb79c005cf3269af8c83ddbe5e) {
                $this->logger->error($_ba3845cb79c005cf3269af8c83ddbe5e);
            }
            throw new RuntimeException($GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_9636e445fbeaa4bbfe5694" . "ed532de0b1"]);
        }
    }
    
    
    
    
    
    
    
    protected function getDatabase()
    {
        return $this->factory->GetInstanceFromConfig($this->config);
    }
}